﻿using DemoApp.Filters;
using System;
using System.Drawing;
using System.Windows.Forms;

namespace DemoApp.Profiling
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Open image
        /// </summary>
        private void openImageToolStripMenuItem_Click(object sender, EventArgs e)
        {
            statusLabel.Text = "";
            // Create a dialog with a filter for jpg files
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "JPG files (*.jpg)|*.jpg";
            
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                // Open new image
                try
                {
                    pictureBox.Image = new Bitmap(ofd.FileName);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Error opening image: " + ex.Message);
                }
            }
        }

        /// <summary>
        /// Exit program
        /// </summary>
        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// Apply oil paint filter
        /// </summary>
        private void oilPaintToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                statusLabel.Text = "Processing...";
                Application.DoEvents();
                // Apply filter
                new OilPaintFilter(5).ApplyInPlace(pictureBox.Image as Bitmap);
                // Refresh displayed image
                pictureBox.Invalidate();
                statusLabel.Text = "Processing finished!";
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error applying filter: " + ex.Message);
            }
        }
    }
}
